#!/usr/bin/env python

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

'''

Is my english better than that of Nicolas: "Sorry for the time, Madame Clinton !"
because it was rainy ! C'est un faux ami.

To use this script with another project, add handler for exemple:

This receive all message, without sub-messsage:
    self.receiver.addCallback("/*", print_handler)
or, touchosc example:
    self.receiver.addCallback("/1/*", print_handler)
with
    def print_handler(message, address):
        print(message, address)

'''

import os,sys
import threading
from txosc import async, dispatch, osc

try:
    from twisted.internet import reactor
except:
    print("You must install python-txosc and maybe python-twisted")
from time import time, sleep

import managementDict
# set instance of class
game = managementDict.gameManagement()

# init
host_multicast = "224.0.0.11"
port_multicast = 18888

t1 = time()
t2 = time()

global multicast_sender
global multicast_reicever
global reactor

def game_server():
    print("Game Server\n\nMultiPass For Freedom\n\nPress q + Enter to quit")
    # Set instance
    global multicast_sender
    global  multicast_reicever
    multicast_sender = UDPMulticastSender(port_multicast)
    multicast_reicever = UDPMulticastReceiver(port_multicast)

    thread1=threading.Thread(target=thread_keyboard)
    thread1.start()

    reactor.run()

def thread_keyboard():
    while 1:
        c = sys.stdin.read(1)
        if c == 'q':
            print("Exit Thread Keyboard")
            global reactor
            reactor.stop()
            os._exit(0)

def reset_handler(message, address):
    global game
    game.reset_data()

def player_data_handler(message, address):
    '''
    This function is called every received message from every player.
    So all data are collected here.
    The frequency of this function is the frequency of blender * players number
    With 4 players: 60 * 4 = 240 Hz
    The frequency of dispatched messages must be 60 Hz because Blender
    received at 60 Hz at the best.
    '''
    # message.getValues() is a list with data
    global game
    global multicast_sender

    game.insert_data_in_dict(message.getValues(), address)

    # send at 60 Hz maxi
    global t1
    if time() - t1 > 0.010:
        t1 = time()
        msg_for_all_players = game.create_msg_for_all_players()
        multicast_sender.send_message(msg_for_all_players)
        global t2
        if time() - t2 > 1:
            t2 = time()
            if msg_for_all_players:
                print("Message sended: %s" % (msg_for_all_players))
                game.delete_disconnected_player()

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, host_multicast),
            listenMultiple=True)
        print("Listening multicast on: %s : %s" % (host_multicast, self.port))
        # handler for all usefull data from a player
        self.receiver.addCallback("/player_data", player_data_handler)
        self.receiver.addCallback("/reset", reset_handler)

# Conversation
while True:
    print "\nSelect :\n"
    print "0 - Exit\n"
    print "Multicast IP is 224.0.0.11 and Port is 18888:"
    print "1 - Change IP or Port\n"
    print "2 - Run Game Server\n"
    selection = input("Enter selection: ")
    if selection == 0:
        os._exit(0)
    elif selection == 1:
        host_multicast = raw_input('Multicast IP ? ')
        unique_port = input('Multicast Port ? ')
    elif selection == 2:
        game_server()
    elif selection >= 0:
        break
